###############################################################################
## This file is part of the Wolfpack module system
## Copyright (C) 1998-2005  Tothwolf <tothwolf@concentric.net>
## and is distributed according to the GNU general public license.
## For full details, read the top of wolfpack.tcl or the file called
## COPYING that was distributed with this code.
##
## $Id: actionfix.tcl,v 1.10 2005/01/04 03:36:43 tothwolf Exp $
##

# name: actionfix
# version: 1.3
# author: Tothwolf <tothwolf@concentric.net>
# license: GNU GPL v2
# description: Adds filt bindings that change mIRC dcc chat actions to .me, \
#	and /me to .me for telnet users.


##
## Fix mIRC dcc chat /me messages
##
## Args:    idx, text
## Returns: processed text
##
proc filt:dccAction {idx text} {
  return ".me [string trim [join [lrange [split $text] 1 end]] \001]"
}

##
## Fix telnet session /me messages
##
## Args:    idx, text
## Returns: processed text
##
proc filt:telnetAction {idx text} {
  return ".me [join [lrange [split $text] 1 end]]"
}

# Bind defaults
array set bindDefaults {
  filt:dccAction {{filt -|- "\001ACTION *\001" {} {}}}
  filt:telnetAction {{filt -|- {/me *} {} {}}}
}
