
# name: mainserver
# version: 0.2
# author: Tothwolf <tothwolf@concentric.net>
# license: GNU GPL v2
# config: mainserver.conf
# description:
# requires: this_module_needs_to_be_converted


global owner

set Config(checkdelay) [expr 30 + [rand 10]]
set Config(retrydelay) [expr 300 + [rand 50]]
set Config(notify) [replaceExpr [replaceExpr $owner "," " "] "  " " "]
set Config(channels) [channels]
set Config(minbots) 2
if {![info exists Loaded]} then {set Loaded 0}

proc CheckServer {retry} {
  global botnet-nick server servers default-port
  variable Config
  variable ModuleName

  set MainServer [string trimleft [string trimright [lindex $servers 0]]]
  if {[string compare $server $MainServer]} then {
    wpLog o * "I'm not on $MainServer - checking to see if I can jump..."
    foreach chan $Config(channels) {
      set found($chan) 0
      foreach bot [bots] {
        if {$found($chan) >= $Config(minbots)} then {
          break
        }
        if {[handonchan $bot $chan]} then {
          set nick [hand2nick $bot $chan]
          if {(![matchattr $bot b]) || (![matchattr $bot o|o $chan]) || \
              (![isop $nick $chan]) || ([onchansplit $nick $chan])} then {
          continue
        }
        incr found($chan)
      }

      if {$found($chan) < $Config(minbots)} then {
        if {$retry} then {
          wpLog o * "Error: Can't jump servers (retry) -- too few op'd bots on $chan, need: $Config(minbots), found: $found($chan)"
          foreach i $Config(notify) {
            catch {
              sendnote ${botnet-nick} $i "${ModuleName}: Error: Failed to connect to server $MainServer."
            }
          }
          timer $Config(checkdelay) [namespace code [list CheckServer 0]]
        } else {
          wpLog o * "Error: Can't jump servers -- too few op'd bots on $chan, need: $Config(minbots), found: $found($chan)"
          utimer $Config(retrydelay) [namespace code [list CheckServer 1]]
        }
        return 0
      }
    }
    regsub -all -- {:} $MainServer { } NewServer
    if 1 "jump $NewServer"
  }
  timer $Config(checkdelay) [namespace code [list CheckServer 0]]
  return 1
}

if {!$Loaded} then {
  timer $Config(checkdelay) [namespace code [list CheckServer 0]]
  set Loaded 1
}
