###############################################################################
## This file is part of the Wolfpack module system
## Copyright (C) 2005  Tothwolf <tothwolf@concentric.net>
## and is distributed according to the GNU general public license.
## For full details, read the top of wolfpack.tcl or the file called
## COPYING that was distributed with this code.
##
## $Id: partyquote.tcl,v 1.9 2005/01/04 03:36:43 tothwolf Exp $
##

# name: partyquote
# version: 0.1
# author: Tothwolf <tothwolf@concentric.net>
# license: GNU GPL v2
# config: partyquote.conf
# description: Display quotes to a user joining the partyline


##
## Display quote to a user joining the partyline
##
## Args:    handle, idx
## Returns: 0
##
# FIXME: only display when first joining partyline --
#        not when exiting a 'control' proc
proc chon:quotes {hand idx} {
  variable configData

  set count 0
  foreach command $configData(quotecommands) {
    if {[catch {set quote [exec $command]} result]} then {
# FIXME: what do we do with this error? Logging could get annoying
    } else {
      foreach line [split $quote "\n"] {
        if {(!$count) && (![regexp -- {^ +$} $line])} then {
          putdcc $idx " "
        }
        putdcc $idx $line
        incr count
      }
      if {![regexp -- {^ +$} $line]} then {
        putdcc $idx " "
      }
    }
  }
  return 0
}

# Configuration defaults, values and descriptions
array set configDefaults {
  quotecommands {string {fortune pom} {} text {shell commands to execute for text}}
}

# Bind defaults
array set bindDefaults {
  chon:quotes {{chon -|- * {} {}}}
}
