###############################################################################
## This file is part of the Wolfpack module system
## Copyright (C) 1998-2005  Tothwolf <tothwolf@concentric.net>
## and is distributed according to the GNU general public license.
## For full details, read the top of wolfpack.tcl or the file called
## COPYING that was distributed with this code.
##
## $Id: skel.tcl,v 1.12 2005/01/04 03:36:44 tothwolf Exp $
##

# name: skel
# version: 1.1
# author: Tothwolf <tothwolf@concentric.net>
# license: GNU GPL v2
# config: skel.conf
# description: Silly example module that adds a dcc, msg, and public command \
#	called `woof' that displays one of 2 random lines each time it's used.
# requires: put validHandle authCheck commandChar


##
## Silly example command: pub
##
## Args:    nick, uhost, hand, chan, arg
## Returns: 1
##
proc pub:woof {nick uhost hand chan arg} {
  return [woof pub putmsg:putnot $chan:$nick $nick $uhost $hand $chan $arg]
}

##
## Silly example command: msg
##
## Args:    nick, uhost, hand, arg
## Returns: 1
##
proc msg:woof {nick uhost hand arg} {
  return [woof msg putnot $nick $nick $uhost $hand "" $arg]
}

##
## Silly example command: dcc
##
## Args:    hand, idx, arg
## Returns: 1
##
proc dcc:woof {hand idx arg} {
  return [woof dcc putdcc $idx "" "" $hand "" $arg]
}

##
## Silly example command
##
## Args:    type {pub/msg/dcc}, action {putnot/putmsg/putdcc},
##          dest {nick/chan/idx}, nick, uhost, hand, chan, arg
## Returns: 1 if the user is auth'd
##          0 otherwise
##
proc woof {type action dest nick uhost hand chan arg} {
  variable configData

  if {[authCheck $type woof $nick $uhost $hand $chan]} then {
    if {[expr [rand 2] - 1]} then {
      put $action $dest $configData(text1)
    } else {
      put $action $dest $configData(text2)
    }
    return 1
  }
  return 0
}

# Configuration defaults, values and descriptions
array set configDefaults {
  text1 {string {Woof! Woof!} {} text {some example text}}
  text2 {string {Arrroooooo!} {} text {more example text}}
}

# Bind defaults
array set bindDefaults {
  pub:woof {{pub p|- woof {cmdchr {cmdsub {{commandChar pub} ^}}} {}}}
  msg:woof {{msg p|- woof {} {}}}
  dcc:woof {{dcc -|- woof {} {}}}
}

# Help Data
array set helpData {
  pub:woof {{} {show example text for example module}}
  msg:woof {{} {show example text for example module}}
  dcc:woof {{} {show example text for example module}}
}
