###############################################################################
## This file is part of the Wolfpack module system
## Copyright (C) 1998-2005  Tothwolf <tothwolf@concentric.net>
## and is distributed according to the GNU general public license.
## For full details, read the top of wolfpack.tcl or the file called
## COPYING that was distributed with this code.
##
## $Id: huntcmds.tcl,v 1.18 2005/01/04 03:36:44 tothwolf Exp $
##

# name: wrpg-huntcmds
# version: 1.0
# author: Tothwolf <tothwolf@concentric.net>
# license: GNU GPL v2
# description:
# requires: huntData commandChar grammarA put putnot isNumber


# FIXME: finish rewrite

##
## Adds the given animal and data to the hunt list: pub
##
## Args:    nick, user@host, handle, channel, arg
## Returns: 1 if user is auth'd
##          0 otherwise
##
proc pub:addhunt {nick uhost hand chan arg} {
  return [addhunt pub putnot $nick $nick $uhost $hand $chan $arg]
}

##
## Adds the given animal and data to the hunt list: msg
##
## Args:    nick, user@host, handle, arg
## Returns: 1 if user is auth'd
##          0 otherwise
##
proc msg:addhunt {nick uhost hand arg} {
  return [addhunt msg putnot $nick $nick $uhost $hand "" $arg]
}

##
## Adds the given animal and data to the hunt list: dcc
##
## Args:    handle, idx, arg
## Returns: 1
##
proc dcc:addhunt {hand idx arg} {
  return [addhunt dcc putdcc $idx "" "" $hand "" $arg]
}

##
## Adds the given animal and data to the hunt list
##
## Args:	type, action, dest, nick, user@host, handle, channel, arg
## Returns: 1 if user is auth'd
##          0 otherwise
##
proc addhunt {type action dest nick uhost hand chan arg} {
#  if {[authCheck $type addhunt $nick $uhost $hand $chan]} then {
#    set arg [split [string trimright $arg]]
#    set arglen [llength $arg]
#
#    if {[llength [split [lindex $arg end] :]] > 5} then {
#      set animal [lrange $arg 0 [expr $arglen - 3]]
#      set options [lindex $arg [expr $arglen - 2]]
#      set diceopt [lindex $arg end]
#    } else {
#      set animal [lrange $arg 0 [expr $arglen - 2]]
#      set options [lindex $arg end]
#    }
#
#    scan $options "%\[^:\]:%\[^:\]:%\[^:\]:%\[^:\]:%\[^:\]:" group hits food hunt sound
#
#    if {(![string length $animal]) || (![info exists group]) || \
#        (![info exists hits]) || (![info exists food]) || \
#        (![info exists hunt]) || (![info exists sound])} then {
#      put $action $dest "Usage: [commandChar $type]addhunt <animal> <group:hits:food:hunt:sound> \[diceopt\]"
#    } else {
#      if {[info exists diceopt]} then {
#        regsub -all -- {[:-]} $diceopt { } diceopt
#      } else {
#        set diceopt ""
#      }
#
#      set animal [huntData realname $animal]
#      if {![string compare "" $animal]} then {
## FIXME: why does this check exist? Is it still needed?
#        if {![isNumber [lindex $animal end]]} then {
#          if {[isNumber $group]} then {
#            if {[isNumber $hits]} then {
#              if {[isNumber $food]} then {
#                if {[isNumber $hunt]} then {
#                  if {[isNumber $sound]} then {
#
#
#                    huntData add $animal [list $group $hits $food $hunt $sound $diceopt]
#
#
#                    put $action $dest "The $animal has been added to the hunt list."
#                  } else {
#                    put $action $dest "Invalid number to set sound to."
#                  }
#                } else {
#                  put $action $dest "Invalid number to set hunt to."
#                }
#              } else {
#                put $action $dest "Invalid number to set food to."
#              }
#            } else {
#              put $action $dest "Invalid number to set hits to."
#            }
#          } else {
#            put $action $dest "Invalid number to set group to."
#          }
#        } else {
#          put $action $dest "Animal's name may not end with a number"
#        }
#      } else {
#        put $action $dest "I already know what [grammarA $animal] is."
#      }
#    }
#    return 1
#  }
#  return 0
}

##
## Removes the given animal from the hunt list: pub
##
## Args:    nick, user@host, handle, channel, arg
## Returns: 1 if user is auth'd
##          0 otherwise
##
proc pub:delhunt {nick uhost hand chan arg} {
  return [delhunt pub putnot $nick $nick $uhost $hand $chan $arg]
}

##
## Removes the given animal from the hunt list: msg
##
## Args:    nick, user@host, handle, arg
## Returns: 1 if user is auth'd
##          0 otherwise
##
proc msg:delhunt {nick uhost hand arg} {
  return [delhunt msg putnot $nick $nick $uhost $hand "" $arg]
}

##
## Removes the given animal from the hunt list: dcc
##
## Args:    handle, idx, arg
## Returns: 1
##
proc dcc:delhunt {hand idx arg} {
  return [delhunt dcc putdcc $idx "" "" $hand "" $arg]
}

##
## Removes the given animal from the hunt list
##
## Args:	type, action, dest, nick, user@host, handle, channel, arg
## Returns: 1 if user is auth'd
##          0 otherwise
##
proc delhunt {type action dest nick uhost hand chan arg} {
#  if {[authCheck $type delhunt $nick $uhost $hand $chan]} then {
#    set arg [split [string trimright $arg]]
#    if {![string compare "" $arg]} then {
#      put $action $dest "Usage: [commandChar $type]delhunt <animal>"
#    } else {
#
#      set animal [huntData realname $animal]
#      if {[string compare "" $animal]} then {
#
#
#        if {[foodData exists $animal]} then {
#          foodData del $animal
#          huntData del $animal
#
#
#          put $action $dest "The $animal has been removed from the hunt and food lists."
#        } else {
#          huntData del $animal
#          put $action $dest "The $animal has been removed from the hunt list."
#        }
#      } else {
#        put $action $dest "I don't know what [grammarA $animal] is."
#      }
#    }
#    return 1
#  }
#  return 0
}

##
## Modifies an animal's data in the hunt list: pub
##
## Args:    nick, user@host, handle, channel, arg
## Returns: 1 if user is auth'd
##          0 otherwise
##
proc pub:chhunt {nick uhost hand chan arg} {
  return [chhunt pub putnot $nick $nick $uhost $hand $chan $arg]
}

##
## Modifies an animal's data in the hunt list: msg
##
## Args:    nick, user@host, handle, arg
## Returns: 1 if user is auth'd
##          0 otherwise
##
proc msg:chhunt {nick uhost hand arg} {
  return [chhunt msg putnot $nick $nick $uhost $hand "" $arg]
}

##
## Modifies an animal's data in the hunt list: dcc
##
## Args:    handle, idx, arg
## Returns: 1
##
proc dcc:chhunt {hand idx arg} {
  return [chhunt dcc putdcc $idx "" "" $hand "" $arg]
}

##
## Modifies an animal's data in the hunt list
##
## Args:	type, action, dest, nick, user@host, handle, channel, arg
## Returns: 1 if user is auth'd
##          0 otherwise
##
proc chhunt {type action dest nick uhost hand chan arg} {
#  if {[authCheck $type chhunt $nick $uhost $hand $chan]} then {
#    set arg [split [string trimright $arg]]
#    set argcount [llength [split [lindex $arg end] :]]
#
#    if {$argcount > 5} then {
#      set animal [lrange $arg 0 [expr [llength $arg] - 3]]
#      set options [lindex $arg [expr [llength $arg] - 2]]
#      set diceopt [lindex $arg end]
#      set tmp [split $options :]
#      scan $options "%\[^:\]:%\[^:\]:%\[^:\]:%\[^:\]:%\[^:\]:" group hits food hunt sound
#    } elseif {$argcount > 2} then {
#      set animal [lrange $arg 0 [expr [llength $arg] - 2]]
#      set options [lindex $arg end]
#      set tmp [split $options :]
#      scan $options "%\[^:\]:%\[^:\]:%\[^:\]:%\[^:\]:%\[^:\]:" group hits food hunt sound
#    } else {
#      set animal [string trimright [lindex [split $arg :] 0]]
#      set animal2 [string trimleft [lindex [split $arg :] 1]]
#    }
#    set animal [huntData realname $animal]
#
#    if {![string compare "" $arg]} then {
#      put $action $dest "Usage: [commandChar $type]chhunt <animal> <group:hits:food:hunt:sound> \[diceopt\] | <oldanimal>:<newanimal>"
#    } elseif {[string compare "" $animal]} then {
#      if {[info exists animal2]} then {
#        if {![string compare $animal $animal2]} then {
## FIXME: why does this check exist? Is it still needed?
#          if {![isNumber [lindex $animal end]]} then {
#
#
#            if {[foodData exists $animal]} then {
#              foodData add $animal2 [foodData get $animal]
#              foodData del $animal
#            }
#            huntData add $animal2 [huntData get $animal]
#            huntData del $animal
#
#
#            put $action $dest "Renamed $animal to $animal2."
#          } else {
#            put $action $dest "Animal name may not end with a number"
#          }
#        } else {
#          put $action $dest "You must specify a different name to rename an animal to."
#        }
#      } else {
#        if {[info exists diceopt]} then {
#          regsub -all -- {[:-]} $diceopt { } diceopt
#        } else {
## FIXME: new data format; dice options
##          set diceopt [lindex $huntdata($animal) 5]
#        }
#        if {[isNumber $group]} then {
#          if {[isNumber $hits]} then {
#            if {[isNumber $food]} then {
#              if {[isNumber $hunt]} then {
#                if {[isNumber $sound]} then {
## FIXME: if provided, show dice options when adding
#
#
#                  if {([lrange $huntdata($animal) 0 4] != $tmp) || ([lindex $huntdata($animal) 5] != $diceopt)} then {
#                    huntData set $animal [list $group $hits $food $hunt $sound $diceopt]
#
#
#                    put $action $dest "The $animal has been set to: $group:$hits:$food:$hunt:$sound"
#                  } else {
#                    put $action $dest "The $animal was already set to: $group:$hits:$food:$hunt:$sound"
#                  }
#                } else {
#                  put $action $dest "Invalid number to set sound to."
#                }
#              } else {
#                put $action $dest "Invalid humber to set hunt to."
#              }
#            } else {
#              put $action $dest "Invalid number to set food to."
#            }
#          } else {
#            put $action $dest "Invalid number to set hits to."
#          }
#        } else {
#          put $action $dest "Invalid number to set group to."
#        }
#      }
#    } else {
#      put $action $dest "I don't know what [grammarA $animal] is."
#    }
#    return 1
#  }
#  return 0
}

##
## Display the hunt list: pub
##
## Args:    nick, user@host, handle, channel, arg
## Returns: 1 if user is auth'd
##          0 otherwise
##
proc pub:listhunt {nick uhost hand chan arg} {
  return [listhunt pub putnot $nick $nick $uhost $hand $chan $arg]
}

##
## Display the hunt list: msg
##
## Args:    nick, user@host, handle, arg
## Returns: 1 if user is auth'd
##          0 otherwise
##
proc msg:listhunt {nick uhost hand arg} {
  return [listhunt msg putnot $nick $nick $uhost $hand "" $arg]
}

##
## Display the hunt list: dcc
##
## Args:    handle, idx, arg
## Returns: 1
##
proc dcc:listhunt {hand idx arg} {
  return [listhunt dcc putdcc $idx "" "" $hand "" $arg]
}

##
## Display the hunt list
##
## Args:	type, action, dest, nick, user@host, handle, channel, arg
## Returns: 1 if user is auth'd
##          0 otherwise
##
proc listhunt {type action dest nick uhost hand chan arg} {
#  if {[authCheck $type listhunt $nick $uhost $hand $chan]} then {
#    set what [split [string trimright $arg]]
#    set count 0
#
## FIXME: move some of this code to huntdata.tcl
#
#    if {[string compare "" $what]} then {
#      foreach i [lsort [array names huntdata]] {
#        lappend list "[join $i] \[[lindex $huntdata($i) 0]:[lindex $huntdata($i) 1]:[lindex $huntdata($i) 2]:[lindex $huntdata($i) 3]:[lindex $huntdata($i) 4]\],"
#        incr count
#      }
#      if {[info exists list]} then {
#        formatLists $action $dest [string trimright [join $list] ,] 160 , , " " "The following animals are on the hunt list ($count): " "(cont): "
#      } else {
#        put $action $dest "The hunt list is empty :("
#      }
#
#
#    } elseif {[isNumber $what]} then {
#      foreach i [lsort [array names huntdata]] {
#        if {![string compare $what [lindex $huntdata($i) 0]]} then {
#          lappend list "[join $i] \[[lindex $huntdata($i) 0]:[lindex $huntdata($i) 1]:[lindex $huntdata($i) 2]:[lindex $huntdata($i) 3]:[lindex $huntdata($i) 4]\],"
#          incr count
#        }
#      }
#      if {[info exists list]} then {
#        formatLists $action $dest [string trimright [join $list] ,] 160 , , " " "The following animals are on the hunt list that are in group $what ($count): " "(cont): "
#      } else {
#        put $action $dest "No animals in the hunt list for group $what"
#      }
#
#
#    } else {
#      set animal [arrayFindElementName huntdata $what]
#      if {[string length $animal]} then {
#        put $action $dest "Info for [join $animal]: \[[lindex $huntdata($animal) 0]:[lindex $huntdata($animal) 1]:[lindex $huntdata($animal) 2]:[lindex $huntdata($animal) 3]:[lindex $huntdata($animal) 4]\]"
#      } else {
#        put $action $dest "I don't know what [grammar_check2 0 $what] is."
#      }
#    }
#    return 1
#  }
#  return 0
}


#############################################################################
#
# FIXME: code from hunt.tcl:

# diceConfig use [namespace code callback_proc]
# proc callback_proc {nick uhost hand chan results} {
#   foreach i $results { ... }
#   return 1
# }


##
## Return a random animal for the given group
##
## Args:    args {group}
## Returns: random animal
##
proc randomAnimal {args} {
  variable dataFormats
  variable huntdata

  set count 0
  set group [lindex $args 0]
  foreach {name data} [array get huntdata] {
    if {([string compare "" $name]) && \
        ([dataFormatValue $dataFormats(huntdata) $data hunt] == 1) && \
        (([string compare "" $group]) || \
         (![string compare $group \
            [dataFormatValue $dataFormats(huntdata) $data group]]))} then {
      lappend list $i
      incr count
    }
  }
  if {$count} then {
    return [lindex [lsort $list] [rand $count]]
  }
  return
}




# sniff out prey; pub
proc pub:sniff {nick uhost hand chan arg} {
  variable huntdata
  variable huntinfo

  if {[validHandle $hand]} then {
    if {[hp test1 $hand 0] != 2} then {
      if {!$huntinfo(active)} then {
        set arg [split [string trimright $arg]]
        if {![string length $arg]} then {
          set animal [random_animal]
          if {[string length $animal]} then {
            set huntinfo(animal) $animal
            set huntinfo(time) [clock seconds]
            putmsg $chan "$nick catches the scent of [grammar_check2 0 [join $animal]] (It has [grammar_check1 0 [lindex $huntdata($animal) 1] hit])"
          } else {
            putnot $nick "No animals are in the hunt list."
          }
        } elseif {[isNumber $arg]} then {
          set animal [random_animal $arg]
          if {[string length $animal]} then {
            set huntinfo(animal) $animal
            set huntinfo(time) [clock seconds]
            putmsg $chan "$nick catches the scent of [grammar_check2 0 [join $animal]] (It has [grammar_check1 0 [lindex $huntdata($animal) 1] hit])"
          } else {
            putnot $nick "No animals are in the hunt list for group $arg"
          }
        } else {
          set animal [arrayFindElementName huntdata $arg]
          if {[string length $animal]} then {
            set huntinfo(animal) $animal
            set huntinfo(time) [clock seconds]
            putmsg $chan "$nick catches the scent of [grammar_check2 0 [join $animal]] (It has [grammar_check1 0 [lindex $huntdata($animal) 1] hit])"
          } else {
            putnot $nick "I don't know what [grammar_check2 0 $arg] is."
          }
        }
      } else {
        putnot $nick "A hunt for [grammar_check2 0 [join $huntinfo(animal)]] is already in progress."
      }
    } else {
      putmsg $chan "Sorry $nick, you are too weak to hunt."
    }
    return 1
  }
  return 0
}


# start a hunt
proc pub:hunt {nick uhost hand chan arg} {
  variable huntdata
  variable huntinfo

  if {[validHandle $hand]} then {
    if {[hp test1 $hand 0] != 2} then {
      if {!$huntinfo(active)} then {
        set arg [split [string trimright $arg]]
        if {[string length $arg]} then {
          set animal [arrayFindElementName huntdata $arg]
        } elseif {[string length $huntinfo(animal)]} then {
          set animal $huntinfo(animal)
        }
        if {[info exists animal]} then {
          if {[string length $animal]} then {
            if {[lev list $hand ""] >= [lindex $huntdata($animal) 0]} then {
              config_dice use [namespace code hunt_dice]
              set diceopt [lindex $huntdata($animal) 5]
              if {[string length $diceopt]} then {
                config_dice configure $diceopt
                set huntinfo(diceopt) 1
              }
              set huntinfo(active) 1
              set huntinfo(caught) 0
              set huntinfo(channel) $chan
              set huntinfo(animal) $animal
              set huntinfo(time) [clock seconds]
              set huntinfo(hits_total) [lindex $huntdata($animal) 1]
              set huntinfo(hits_remaining) $huntinfo(hits_total)
              set huntinfo(hits_scored) 0
              putmsg $chan "Hunt for [grammar_check2 0 [join $animal]] now active! (It has [grammar_check1 0 $huntinfo(hits_total) hit])"
            } else {
              putnot $nick "Your level is not high enough to start a hunt for [grammar_check2 0 [join $animal]]"
            }
          } else {
            putnot $nick "I don't know what [grammar_check2 0 $arg] is."
          }
        } else {
          putnot $nick "You must sniff out an animal or specify what to hunt."
        }
      } else {
        putnot $nick "A hunt for [grammar_check2 0 [join $huntinfo(animal)]] is already in progress."
      }
    } else {
      putmsg $chan "Sorry $nick, you are too weak to hunt."
    }
    return 1
  }
  return 0
}


#FIXME: $huntinfo(channel)
# immediately terminate a hunt
proc pub:endhunt {nick uhost hand chan arg} {
  variable huntdata
  variable huntinfo

  if {[validHandle $hand]} then {
    if {[hp test1 $hand 0] != 2} then {
      if {$huntinfo(active)} then {
        set arg [split [string trimright $arg]]
        if {[string length $arg]} then {
          set animal [arrayFindElementName huntdata $arg]
        } else {
          set animal $huntinfo(animal)
        }
        if {[string length $animal]} then {
          if {[lev list $hand ""] >= [lindex $huntdata($animal) 0]} then {
            if {![string compare $animal $huntinfo(animal)]} then {
              putmsg $chan "Hunt for [grammar_check2 0 [join $huntinfo(animal)]] ended, [grammar_check3 [grammar_check1 0 $huntinfo(hits_scored) hit]] scored out of $huntinfo(hits_total)."
              clear_hunt
            } else {
              putnot $nick "[grammar_check2 1 [join $animal]] is not being hunted, [grammar_check2 0 [join $huntinfo(animal)]] is."
            }
          } else {
            putnot $nick "Your level is not high enough to end a hunt for [grammar_check2 0 [join $animal]]"
          }
        } else {
          putnot $nick "I don't know what [grammar_check2 0 $arg] is."
        }
      } else {
        putnot $nick "There wasn't a hunt active."
      }
    } else {
      putnot $chan "Sorry $nick, you are too weak to hunt."
    }
    return 1
  }
  return 0
}


# register caught prey from the hunt; pub
proc pub:caught {nick uhost hand chan arg} {
  variable conf
  variable huntinfo
  variable huntdata
  variable fooddata

  if {[validHandle $hand]} then {
    if {[hp test1 $hand 0] != 2} then {
      set arg [split [string trimright $arg]]
      if {[string length $arg]} then {
        set animal [arrayFindElementName huntdata $arg]
      } elseif {$huntinfo(active)} then {
        set animal $huntinfo(animal)
      }
      if {[info exists animal]} then {
        if {[string length $animal]} then {
          if {$huntinfo(active)} then {
            if {!$conf(autocaught)} then {
              if {![string compare $animal $huntinfo(animal)]} then {
                if {[hunt_catch $animal]} then {
                  putmsg $chan "There is now enough [join $animal] for [lindex $fooddata($animal) 0] wolves."
                } else {
                  putnot $nick "The [join $animal] hasn't been caught yet!"
                }
              } else {
                putnot $nick "[grammar_check2 1 [join $animal]] was not caught, [grammar_check2 0 [join $huntinfo(animal)]] was."
              }
            } else {
              putnot $nick "The caught command is unnecessary since autocaught is enabled."
            }
          } elseif {[lindex $huntdata($animal) 3]} then {
            if {[hunt_catch $animal]} then {
              putmsg $chan "There is now enough [join $animal] for [lindex $fooddata($animal) 0] wolves."
            }
          } else {
            putnot $nick "There isn't a hunt active."
          }
        } else {
          putnot $nick "I don't know what [grammar_check2 0 [join $animal]] is."
        }
      } else {
        putnot $nick "You must hunt an animal or specify what to catch."
      }
    } else {
      putmsg $chan "Sorry $nick, you are too weak to hunt."
    }
    return 1
  }
  return 0
}


# register caught prey from the hunt
proc hunt_catch {animal} {
  variable huntinfo
  variable huntdata
  variable fooddata
  variable fooddata_changed

  if {($huntinfo(caught)) || (![lindex $huntdata($animal) 3])} then {
    if {![info exists fooddata($animal)]} then {
      set fooddata($animal) "[lindex $huntdata($animal) 2] [clock seconds]"
    } else {
      set fooddata($animal) "[expr [lindex $fooddata($animal) 0] + [lindex $huntdata($animal) 2]] [clock seconds]"
    }
    set fooddata_changed 1
    if {$huntinfo(active)} then {
      clear_hunt
    }
    return 1
  }
  return 0
}


# score a hunt
proc hunt_dice {nick uhost hand chan result} {
  variable conf
  variable huntinfo
  variable huntdata
  variable NamespaceParent

  if {$huntinfo(active)} then {
    if {!$huntinfo(caught)} then {
      if {[hp test1 $hand 0] != 2} then {
        if {(($conf(allownonpack)) && (![validuser $hand])) || ([lev list $hand 0])} then {
          set huntinfo(time) [clock seconds]
          set hunt_hits1 0
          set hunt_hits2 0
          set hunt_hits3 $huntinfo(hits_remaining)
          foreach i $result {
            if {($i >= $${NamespaceParent}::wrpgdice::diceconf(low1_1)) && \
                ($i <= $${NamespaceParent}::wrpgdice::diceconf(low1_2))} then {
              incr hunt_hits1 2
            } elseif {($i >= $${NamespaceParent}::wrpgdice::diceconf(low2_1)) && \
                      ($i <= $${NamespaceParent}::wrpgdice::diceconf(low2_2))} then {
              incr hunt_hits1
            } elseif {($i >= $${NamespaceParent}::wrpgdice::diceconf(high1_1)) && \
                      ($i <= $${NamespaceParent}::wrpgdice::diceconf(high1_2))} then {
              incr hunt_hits2
              incr huntinfo(hits_scored)
              incr huntinfo(hits_remaining) -1
            } elseif {($i >= $${NamespaceParent}::wrpgdice::diceconf(high2_1)) && \
                      ($i <= $${NamespaceParent}::wrpgdice::diceconf(high2_2))} then {
              incr hunt_hits2 2
              incr huntinfo(hits_scored) 2
              incr huntinfo(hits_remaining) -2
            }
          }
          foreach i $result {
            lappend reply "\002$i\002,"
          }
          if {$hunt_hits1 > 0} then {
            if {[hp decr $hand $hunt_hits1]} then {
              lappend reply "you took [grammar_check1 0 $hunt_hits1 point] of damage,"
            }
          }
          if {$hunt_hits2 > 0} then {
            if {$huntinfo(hits_remaining) > 0} then {
              lappend reply "the [join $huntinfo(animal)] recieved [grammar_check1 0 $hunt_hits2 point] of damage,"
            } else {
              lappend reply "the [join $huntinfo(animal)] recieved [grammar_check1 0 $hunt_hits3 point] of damage,"
            }
          }
          if {$huntinfo(hits_remaining) > 0} then {
            lappend reply "the [join $huntinfo(animal)] has [grammar_check1 0 $huntinfo(hits_remaining) hit] left out of $huntinfo(hits_total),"
          } else {
            if {$conf(autocaught)} then {
              lappend reply "the [join $huntinfo(animal)] has been caught!"
            } else {
              lappend reply "the [join $huntinfo(animal)] has been killed!"
            }
            if {[lindex $huntdata($huntinfo(animal)) 4]} then {
              personality huntkill "%nick $nick" "%chan $chan" "%animal $huntinfo(animal)"
            }
            set huntinfo(caught) 1
            hunt_catch $huntinfo(animal)
          }
          if {[info exists reply]} then {
            putmsg $chan "$nick rolls a [string trimright [join $reply] ,]"
            return 1
          }
        } else {
          putnot $nick "Your level is not high enough to end a hunt for [grammar_check2 0 [join $huntinfo(animal)]]"
          return 1
        }
      } else {
        putmsg $chan "Sorry $nick, you are too weak to hunt."
        return 1
      }
    }
  }
  return 0
}


# clear all the info from a hunt
proc clear_hunt {} {
  variable huntinfo

  if {$huntinfo(diceopt)} then {
    config_dice reset ""
  }
  set huntinfo(animal) ""
  set huntinfo(active) 0
  set huntinfo(caught) 0
  set huntinfo(channel) ""
  set huntinfo(time) 0
  set huntinfo(diceopt) 0
  if {[info exists huntinfo(hits_total)]} then {unset huntinfo(hits_total)}
  if {[info exists huntinfo(hits_remaining)]} then {unset huntinfo(hits_remaining)}
  if {[info exists huntinfo(hits_scored)]} then {unset huntinfo(hits_scored)}
  return 0
}

# check for and timeout an inactive hunt once a minute
proc time:minutely {min hour day month year} {
  variable conf
  variable huntinfo

  if {$huntinfo(active)} then {
    if {$huntinfo(time)} then {
      if {[expr ([clock seconds] - $huntinfo(time)) / 60] >= $conf(timeout)} then {
        if {[validchan $huntinfo(channel)]} then {
          putmsg $huntinfo(channel) "Hunt for [grammar_check2 0 [join $huntinfo(animal)]] timed out after [grammar_check1 0 $conf(timeout) minute], [grammar_check3 [grammar_check1 0 $huntinfo(hits_scored) hit]] scored out of $huntinfo(hits_total)."
        }
        clear_hunt
      }
    }
  }
  return 0
}


##
## Init module specific things at load time
##
## Args:    none
## Returns: nothing
##
proc ModuleInit {} {
  variable huntInfo
  variable huntInfoDefaults

  if {![info exists huntInfoDefaults]} then {
    # Default settings
    array set huntInfoDefaults {
      active 0
      animal ""
      caught 0
      channel ""
      diceopt ""
      time 0
    }
  }
  foreach {name data} [array get huntInfoDefaults] {
    if {![info exists huntInfo($name)]} then {
      set huntInfo($name) $data
    }
  }
  return
}

#
#############################################################################


# Bind defaults
array set bindDefaults {
  pub:addhunt {{pub m|m addhunt {cmdchr {cmdsub {{commandChar pub} ^}}} {}}}
  pub:delhunt {{pub m|m delhunt {cmdchr {cmdsub {{commandChar pub} ^}}} {}}}
  pub:chhunt {{pub m|m chhunt {cmdchr {cmdsub {{commandChar pub} ^}}} {}}}
  pub:listhunt {{pub m|m listhunt {cmdchr {cmdsub {{commandChar pub} ^}}} {}}}
  msg:addhunt {{msg m|m addhunt {} {}}}
  msg:delhunt {{msg m|m delhunt {} {}}}
  msg:chhunt {{msg m|m chhunt {} {}}}
  msg:listhunt {{msg m|m listhunt {} {}}}
  dcc:addhunt {{dcc m|m addhunt {} {}}}
  dcc:delhunt {{dcc m|m delhunt {} {}}}
  dcc:chhunt {{dcc m|m chhunt {} {}}}
  dcc:listhunt {{dcc m|m listhunt {} {}}}
  pub:sniff {{pub P|P sniff {cmdchr {cmdsub {{commandChar pub} ^}}} {}}}
  pub:hunt {{pub P|P hunt {cmdchr {cmdsub {{commandChar pub} ^}}} {}}}
  pub:endhunt {{pub P|P endhunt {cmdchr {cmdsub {{commandChar pub} ^}}} {}}}
  pub:caught {{pub P|P caught {cmdchr {cmdsub {{commandChar pub} ^}}} {}}}
  time:minutely {{time -|- {* * * * *} {} {}}}
}

# Help Data
array set helpData {
  pub:addhunt {{<animal> <size:hits:hunt:sound>} {adds an animal to the hunt database}}
  pub:delhunt {{<animal>} {removes an animal from the hunt database}}
  pub:chhunt {{<animal> <size:hits:hunt:sound> | <oldanimal>:<newanimal>} {changes options for an animal in the hunt database}}
  pub:listhunt {{[animal|size]} {lists the hunt database}}
  msg:addhunt {{<animal> <size:hits:hunt:sound>} {adds an animal to the hunt database}}
  msg:delhunt {{<animal>} {removes an animal from the hunt database}}
  msg:chhunt {{<animal> <size:hits:hunt:sound> | <oldanimal>:<newanimal>} {changes options for an animal in the hunt database}}
  msg:listhunt {{[animal|size]} {lists the hunt database}}
  dcc:addhunt {{<animal> <size:hits:hunt:sound>} {adds an animal to the hunt database}}
  dcc:delhunt {{<animal>} {removes an animal from the hunt database}}
  dcc:chhunt {{<animal> <size:hits:hunt:sound> | <oldanimal>:<newanimal>} {changes options for an animal in the hunt database}}
  dcc:listhunt {{[animal|size]} {lists the hunt database}}
  pub:sniff {{[animal|size]} {sniffs out game for a hunt}}
  pub:hunt {{[animal]} {starts a hunt for the given animal or the animal sniffed out}}
  pub:endhunt {{[animal]} {ends a hunt}}
  pub:caught {{[animal]} {registers a kill in the food database}}
}
