###############################################################################
## This file is part of the Wolfpack module system
## Copyright (C) 1998-2005  Tothwolf <tothwolf@concentric.net>
## and is distributed according to the GNU general public license.
## For full details, read the top of wolfpack.tcl or the file called
## COPYING that was distributed with this code.
##
## $Id: userdata.tcl,v 1.8 2005/01/04 03:36:44 tothwolf Exp $
##

# name: wrpg-userdata
# version: 1.0
# author: Tothwolf <tothwolf@concentric.net>
# license: GNU GPL v2
# description: Wolf RPG shared user status and point data support.
# requires: updateStatusData updatePointData


##
## Check/update user status and point data hourly
##
## Args:    minute, hour, day, month, year
## Returns: 0
##
proc time:hourly {min hour day month year} {
  updateStatusData
  updatePointData
  return 0
}

# Bind defaults
array set bindDefaults {
  time:hourly {{time -|- {00 * * * *} {} {}}}
}
